#! /bin/bash -ex

MYDIR=$(dirname ${BASH_SOURCE[0]})
source ${MYDIR}/../../test/utils.sh

LOCALPORT=${LOCALPORT:-8888}

wait_until_ready app=coffee,example=externalname
wait_until_ready app=tea,example=externalname

wait_until_ready app=varnish-ingress
wait_until_configured app=varnish-ingress

kubectl port-forward svc/varnish-ingress ${LOCALPORT}:80 >/dev/null &
trap 'kill $(jobs -p)' EXIT
wait_for_port ${LOCALPORT}

# Give VMOD dynamic enough time to update the IP from DNS.
sleep 30

varnishtest ${TESTOPTS} -Dlocalport=${LOCALPORT} ../hello/cafe.vtc
