/*
 * Copyright (c) 2022 UPLEX Nils Goroll Systemoptimierung
 * All rights reserved
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "code.uplex.de/uplex-varnish/k8s-ingress/pkg/apis/varnishingress/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeTemplateConfigs implements TemplateConfigInterface
type FakeTemplateConfigs struct {
	Fake *FakeIngressV1alpha1
	ns   string
}

var templateconfigsResource = schema.GroupVersionResource{Group: "ingress.varnish-cache.org", Version: "v1alpha1", Resource: "templateconfigs"}

var templateconfigsKind = schema.GroupVersionKind{Group: "ingress.varnish-cache.org", Version: "v1alpha1", Kind: "TemplateConfig"}

// Get takes name of the templateConfig, and returns the corresponding templateConfig object, and an error if there is any.
func (c *FakeTemplateConfigs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.TemplateConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(templateconfigsResource, c.ns, name), &v1alpha1.TemplateConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TemplateConfig), err
}

// List takes label and field selectors, and returns the list of TemplateConfigs that match those selectors.
func (c *FakeTemplateConfigs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.TemplateConfigList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(templateconfigsResource, templateconfigsKind, c.ns, opts), &v1alpha1.TemplateConfigList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.TemplateConfigList{ListMeta: obj.(*v1alpha1.TemplateConfigList).ListMeta}
	for _, item := range obj.(*v1alpha1.TemplateConfigList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested templateConfigs.
func (c *FakeTemplateConfigs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(templateconfigsResource, c.ns, opts))

}

// Create takes the representation of a templateConfig and creates it.  Returns the server's representation of the templateConfig, and an error, if there is any.
func (c *FakeTemplateConfigs) Create(ctx context.Context, templateConfig *v1alpha1.TemplateConfig, opts v1.CreateOptions) (result *v1alpha1.TemplateConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(templateconfigsResource, c.ns, templateConfig), &v1alpha1.TemplateConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TemplateConfig), err
}

// Update takes the representation of a templateConfig and updates it. Returns the server's representation of the templateConfig, and an error, if there is any.
func (c *FakeTemplateConfigs) Update(ctx context.Context, templateConfig *v1alpha1.TemplateConfig, opts v1.UpdateOptions) (result *v1alpha1.TemplateConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(templateconfigsResource, c.ns, templateConfig), &v1alpha1.TemplateConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TemplateConfig), err
}

// Delete takes name of the templateConfig and deletes it. Returns an error if one occurs.
func (c *FakeTemplateConfigs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(templateconfigsResource, c.ns, name), &v1alpha1.TemplateConfig{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeTemplateConfigs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(templateconfigsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.TemplateConfigList{})
	return err
}

// Patch applies the patch and returns the patched templateConfig.
func (c *FakeTemplateConfigs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.TemplateConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(templateconfigsResource, c.ns, name, pt, data, subresources...), &v1alpha1.TemplateConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TemplateConfig), err
}
