/*
 * Copyright (c) 2022 UPLEX Nils Goroll Systemoptimierung
 * All rights reserved
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "code.uplex.de/uplex-varnish/k8s-ingress/pkg/apis/varnishingress/v1alpha1"
	scheme "code.uplex.de/uplex-varnish/k8s-ingress/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// TemplateConfigsGetter has a method to return a TemplateConfigInterface.
// A group's client should implement this interface.
type TemplateConfigsGetter interface {
	TemplateConfigs(namespace string) TemplateConfigInterface
}

// TemplateConfigInterface has methods to work with TemplateConfig resources.
type TemplateConfigInterface interface {
	Create(ctx context.Context, templateConfig *v1alpha1.TemplateConfig, opts v1.CreateOptions) (*v1alpha1.TemplateConfig, error)
	Update(ctx context.Context, templateConfig *v1alpha1.TemplateConfig, opts v1.UpdateOptions) (*v1alpha1.TemplateConfig, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.TemplateConfig, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.TemplateConfigList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.TemplateConfig, err error)
	TemplateConfigExpansion
}

// templateConfigs implements TemplateConfigInterface
type templateConfigs struct {
	client rest.Interface
	ns     string
}

// newTemplateConfigs returns a TemplateConfigs
func newTemplateConfigs(c *IngressV1alpha1Client, namespace string) *templateConfigs {
	return &templateConfigs{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the templateConfig, and returns the corresponding templateConfig object, and an error if there is any.
func (c *templateConfigs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.TemplateConfig, err error) {
	result = &v1alpha1.TemplateConfig{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("templateconfigs").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of TemplateConfigs that match those selectors.
func (c *templateConfigs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.TemplateConfigList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.TemplateConfigList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("templateconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested templateConfigs.
func (c *templateConfigs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("templateconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a templateConfig and creates it.  Returns the server's representation of the templateConfig, and an error, if there is any.
func (c *templateConfigs) Create(ctx context.Context, templateConfig *v1alpha1.TemplateConfig, opts v1.CreateOptions) (result *v1alpha1.TemplateConfig, err error) {
	result = &v1alpha1.TemplateConfig{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("templateconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(templateConfig).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a templateConfig and updates it. Returns the server's representation of the templateConfig, and an error, if there is any.
func (c *templateConfigs) Update(ctx context.Context, templateConfig *v1alpha1.TemplateConfig, opts v1.UpdateOptions) (result *v1alpha1.TemplateConfig, err error) {
	result = &v1alpha1.TemplateConfig{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("templateconfigs").
		Name(templateConfig.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(templateConfig).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the templateConfig and deletes it. Returns an error if one occurs.
func (c *templateConfigs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("templateconfigs").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *templateConfigs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("templateconfigs").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched templateConfig.
func (c *templateConfigs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.TemplateConfig, err error) {
	result = &v1alpha1.TemplateConfig{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("templateconfigs").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
