/*
 * Copyright (c) 2022 UPLEX Nils Goroll Systemoptimierung
 * All rights reserved
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "code.uplex.de/uplex-varnish/k8s-ingress/pkg/apis/varnishingress/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// TemplateConfigLister helps list TemplateConfigs.
// All objects returned here must be treated as read-only.
type TemplateConfigLister interface {
	// List lists all TemplateConfigs in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.TemplateConfig, err error)
	// TemplateConfigs returns an object that can list and get TemplateConfigs.
	TemplateConfigs(namespace string) TemplateConfigNamespaceLister
	TemplateConfigListerExpansion
}

// templateConfigLister implements the TemplateConfigLister interface.
type templateConfigLister struct {
	indexer cache.Indexer
}

// NewTemplateConfigLister returns a new TemplateConfigLister.
func NewTemplateConfigLister(indexer cache.Indexer) TemplateConfigLister {
	return &templateConfigLister{indexer: indexer}
}

// List lists all TemplateConfigs in the indexer.
func (s *templateConfigLister) List(selector labels.Selector) (ret []*v1alpha1.TemplateConfig, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.TemplateConfig))
	})
	return ret, err
}

// TemplateConfigs returns an object that can list and get TemplateConfigs.
func (s *templateConfigLister) TemplateConfigs(namespace string) TemplateConfigNamespaceLister {
	return templateConfigNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// TemplateConfigNamespaceLister helps list and get TemplateConfigs.
// All objects returned here must be treated as read-only.
type TemplateConfigNamespaceLister interface {
	// List lists all TemplateConfigs in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.TemplateConfig, err error)
	// Get retrieves the TemplateConfig from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.TemplateConfig, error)
	TemplateConfigNamespaceListerExpansion
}

// templateConfigNamespaceLister implements the TemplateConfigNamespaceLister
// interface.
type templateConfigNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all TemplateConfigs in the indexer for a given namespace.
func (s templateConfigNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.TemplateConfig, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.TemplateConfig))
	})
	return ret, err
}

// Get retrieves the TemplateConfig from the indexer for a given namespace and name.
func (s templateConfigNamespaceLister) Get(name string) (*v1alpha1.TemplateConfig, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("templateconfig"), name)
	}
	return obj.(*v1alpha1.TemplateConfig), nil
}
